#!/usr/bin/perl

######################################################################
# CGI Information
#---------------------------------------------------------------------
$Global{DevelName}     = 'Ӵȣ';                  #  
$Global{DevelMail}     = 'lawwal@way.co.kr';        #  E-mail
$Global{DevelHome}     = 'http://way.co.kr';        # Ȩ
$Global{CgiName}       = 'Way-MAIL';                # CGI Ī
$Global{CgiVersion}    = '1.5';                     # CGI 
$Global{LastModified}  = '2000-06-12';              #  
######################################################################
# History
#---------------------------------------------------------------------
# 1998-08-06          by lawwal Ver 1.0
# 1999-02-26          by lawwal Ver 1.1
# 1999-04-27          by lawwal Ver 1.2 (Plus WinNT/98/95)
# 1999-10-30 ~ 11-04  by lawwal Ver 1.5 beta
# 2000-06-11 ~ 06-12  by lawwal Ver 1.5
######################################################################
# General Library
#---------------------------------------------------------------------
require "../lib/Way-LIB.cgi";
######################################################################
# CGI Main
#---------------------------------------------------------------------
main();
sub main {
Way::DataConv(*Dc);
ReadConf();
LimitAccess();
@ToMailArr = DataUsing();
CheckData();
MailSend();
Result();
}
######################################################################
# Using Variable
#---------------------------------------------------------------------
#  $Dc{LocalConfig};
#  $Dc{ToMail};                 # Require or AdminReceive
#  $Dc{AdminReceive};
#  $Dc{FromName};
#  $Dc{FromMail};
#  $Dc{Subject};                # Require
#  $Dc{Message};                # Require
#  $Dc{MailType};               # TEXT(*)/HTML
#  $Dc{FromUserReceive};        # Y/N(*)
######################################################################
# Read Configure
#---------------------------------------------------------------------
sub ReadConf { 
Way::GetConf(*Gc, "../conf/general.cgi");
  %Gc = %{$Gc{_Global}};                           # ⺻
  undef $Gc{TimeAdjust} if $Gc{TimeAdjust} eq '';  # ð
Way::GetConf(*Mc, "../conf/message.cgi");
  %Mc = %{$Mc{_Global}};                           # ޼ 
Way::GetConf(*Lcfg, "../conf/mail.cgi");
  %LGlobal = %{$Lcfg{_Global}};                    # Way-MAIL ⺻ 
$Dc{LocalConfig} || ($Dc{LocalConfig} = "Default");
  %Lc = %{$Lcfg{$Dc{LocalConfig}}};                # Way-MAIL  
# Way-MAIL ⺻ Ǿ  ° ⺻ 
foreach (keys %LGlobal) {
  if(defined $LGlobal{$_} && !defined $Lc{$_}) {
     $Lc{$_}  = $LGlobal{$_}; } }
undef %Lcfg; undef %LGlobal;
}
######################################################################

sub LimitAccess {
foreach (split(/,\s?/, $Lc{ExecAllowURL})) {
  if ($ENV{"HTTP_REFERER"} =~ /^$_/i) { $tmp = 1; }
}
if (!$tmp) { Way::GoBackMsg("", $Mc{NotPermUrl}, 1); exit; }
}

sub DataUsing {
foreach (keys %Dc) { if($_ ne "Message") { Way::SpaceDel(\$Dc{$_}); } }
#  ּҰ  ʾ ⺻(General) ּ 
$Lc{AdminMail} || ($Lc{AdminMail} = $Gc{AdminMail});
if($Lc{AdminMail} eq "admin\@sample.way.co.kr") {
   Way::GoBackMsg("", "$Mc{AdminMailErr}", 1); exit; }
$Lc{MaxFileSize} =~ s/\D//g;
$Lc{MaxFileCount} += 0;
#  ּ 迭ȭ
# , ; SPACE Enter
$Dc{ToMail} =~ s/\,+|\;+|\s+|\n+/\|/g;
return split(/\|+/, $Dc{ToMail});
}

sub CheckData {
my @Err;
if($Dc{Subject} eq '') { push(@Err, "$Mc{Subject}"); }
if($Dc{Message} eq '') { push(@Err, "$Mc{Message}"); }
#    ʰ,  ּҵ Էµ ʾ 
if($Dc{AdminReceive} ne "Y" &&
   !@ToMailArr)   { push(@Err, "$Mc{ToMail}"); }
# ߼  ʼ׸ ߴµ Է´ ִ°
if($Lc{FromUserRequire} eq "Y" && $Dc{FromMail} eq '') {
   push(@Err, "$Mc{FromMail}"); }
if($Lc{FromUserRequire} eq "Y" && $Dc{FromName} eq '') {
    push(@Err, "$Mc{FromName}"); }
# ߼ۼ ʰ 
if($#ToMailArr + 1 > $Lc{MaxSendMsg}) {
    $Mc{MaxSendMsgOver} =~ s/\%1/$Lc{MaxSendMsg}/g;
    push(@Err, "$Mc{MaxSendMsgOver}"); }
# ߼ ּҰ  ʴ°
if(!Way::CheckMail($Dc{FromMail}, 1)) {
  my $tmp = $Mc{Mail};
  $tmp =~ s/\%1/$Dc{FromMail}/g; push(@Err, $tmp); } 
# ޴ ּҰ  ʴ°
foreach (@ToMailArr) {
  my $tmp = $Mc{Mail};
  if(!Way::CheckMail($_)) { $tmp =~ s/\%1/$_/g; push(@Err, $tmp); }
}
# ÷ ũ üũ
foreach (1..$Lc{MaxFileCount}) {
  my $tmp = $Mc{MaxFileSizeOver};
  if($Dc{"File$_"}->{size} > $Lc{MaxFileSize}) {
    $tmp =~ s/\%1/$Dc{"File$_"}->{name}/g; push(@Err, $tmp); }
}
if(@Err) { ErrorPrint(@Err); }
}

sub ErrorPrint {
my @Err = @_;
my $ErrStr;
foreach (sort @Err) { $ErrStr .= " - $_ \n"; }
Way::GoBackMsg($Mc{Error}, $ErrStr, 1); exit;
}

sub MailSend {
my ($MailType, $Message);
if($Dc{AdminReceive} eq "Y") { @ToMailArr = ($Lc{AdminMail}, @ToMailArr); }
$Dc{FromName} = ($Dc{FromName} ? $Dc{FromName} : "Nobody");
$Dc{FromMail} = ($Dc{FromMail} ? $Dc{FromMail} : "Nobody");
if ($Dc{FromUserReceive} eq "Y") { @Cc = ($Dc{FromMail}); }
if($Dc{MailType} eq "HTML") {
    $MailType = 1;
    $Message = "$Dc{Message}<br>\n";
    $Message .= "-" x 75 . "<br>\n";
    $Message .= " = Powered by Way-SERIES  ......  <A HREF=http://way.co.kr>";
    $Message .= "http://way.co.kr</a> =\n"; }
else {
    $Message = "$Dc{Message}\n";
    $Message .= "-" x 75 . "\n";
    $Message .= " = Powered by Way-SERIES  ......  http://way.co.kr =\n"; }
foreach (1..$Lc{MaxFileCount}) {
if($Dc{"File$_"}->{name} ne '') { push(@AttachList, "File$_"); }
}
$rs = Way::SendMail(0, $Gc{SendmailPath}, $Gc{SMTPServer}, $Lc{AdminMail},
$Dc{FromMail}, $Dc{FromName}, \@ToMailArr, \@Cc, \@Bcc, $Dc{Subject}, $Message,
$MailType,
\@AttachList, \%Dc,
$Gc{CharSet}, $Gc{MailTextEncode});
if(!$rs) { Way::GoBackMsg("", $Mc{MailSend}, 1); exit; }
}

sub Result {
if($Lc{ResultURL}) { Way::LocationHeader($Lc{ResultURL}); exit; }
else { Way::GoBackMsg("", $Mc{SendResult}, 2); exit; }
}

