#!/usr/bin/perl

######################################################################
# CGI Information
#---------------------------------------------------------------------
$Global{DevelName}     = 'Ӵȣ';                  #  
$Global{DevelMail}     = 'lawwal@way.co.kr';        #  E-mail
$Global{DevelHome}     = 'http://way.co.kr';        # Ȩ
$Global{CgiName}       = 'Way-SEARCH';              # CGI Ī
$Global{CgiVersion}    = '1.3';                     # CGI 
$Global{LastModified}  = '2000-06-12';              #  
######################################################################
# History
#---------------------------------------------------------------------
# 1999-03-08 ~ 03-09  by lawwal Ver 1.0
# 1999-04-27          by lawwal Ver 1.1 (Plus WinNT/98/95)
# 1999-11-06 ~ 11-07  by lawwal Ver 1.3 beta
# 2000-06-11 ~ 06-12  by lawwal Ver 1.3
######################################################################
# General Library
#---------------------------------------------------------------------
require "../lib/Way-LIB.cgi";
######################################################################
# CGI Main
#---------------------------------------------------------------------
main();
sub main {
Way::DataConv(*Dc);
ReadConf();
@Range = DataUsing();
FileSelect();
@Find = Search(\@Range, \@FileList);
Result(\@Range, \@Find);
}
######################################################################
# Using Variable
#---------------------------------------------------------------------
#  $Dc{LocalConfig};
######################################################################
# Read Configure
#---------------------------------------------------------------------
sub ReadConf { 
Way::GetConf(*Gc, "../conf/general.cgi");
  %Gc = %{$Gc{_Global}};                           # ⺻
  undef $Gc{TimeAdjust} if $Gc{TimeAdjust} eq '';  # ð
Way::GetConf(*Mc, "../conf/message.cgi");
  %Mc = %{$Mc{_Global}};                           # ޼ 
Way::GetConf(*Lcfg, "../conf/search.cgi");
  %LGlobal = %{$Lcfg{_Global}};                    # Way-SEARCH ⺻ 
$Dc{LocalConfig} || ($Dc{LocalConfig} = "Default");
  %Lc = %{$Lcfg{$Dc{LocalConfig}}};                # Way-SEARCH  
# Way-SEARCH ⺻ Ǿ  ° ⺻ 
foreach (keys %LGlobal) {
  if(defined $LGlobal{$_} && !defined $Lc{$_}) {
     $Lc{$_}  = $LGlobal{$_}; } }
undef %Lcfg; undef %LGlobal;
}
######################################################################

sub DataUsing {
my @Range;
Way::SpaceDel(\$Dc{Word});
$Dc{Meth} || ($Dc{Meth} = "or");
if($Dc{Count} !~ /All/i && $Dc{Count} < 1) { $Dc{Count} = 15; }
if($Dc{Title} eq '' && $Dc{Key} eq '' && $Dc{Text} eq '' && $Dc{File} eq '') {
  push(@Range, "Title", "Key", "Text"); }
$Dc{Title} && (push(@Range, "Title"));
$Dc{Key} && (push(@Range, "Key"));
$Dc{Text} && (push(@Range, "Text"));
$Dc{File} && (push(@Range, "File"));
$sw_encode = $Dc{Word};
$sw_encode =~ s/([^0-9a-zA-Z]{1})/'%'.unpack("H2",$1)/ge;
$sw_encode =~ s/ /+/g;
$sw_encode =~ s/%20/+/g;
$Query  = "LocalConfig=$Dc{LocalConfig}";
$Query .= "&Word=$sw_encode&Meth=$Dc{Meth}&Count=$Dc{Count}";
$Query .= "&Title=$Dc{Title}&Key=$Dc{Key}&Text=$Dc{Text}&File=$Dc{File}";
return @Range;
}

sub FileSelect {
if($Dc{Word} eq '') { return; }
foreach (split(/\,+/, $Lc{SearchDir})) {
  my ($dir, $url) = $_ =~ /^([^\[]*)\[?([^\]]*)\]?$/;
  Way::SpaceDel(\$dir);
  chop $dir if $dir =~ /\/$/; FileSelectAct($dir); }
my $file;
foreach $file (@FileList) { 
  my $ck = 1;
  if($Lc{SearchExt}) {
    foreach (split(/\,+/, $Lc{SearchExt})) { 
      Way::SpaceDel(\$_);
      if($file =~ /\.$_$/) { $ck = 1; last; }
      else { $ck = 0 ; } }
  }
  elsif($Lc{ExceptExt}) {
    foreach (split(/\,+/, $Lc{ExceptExt})) { 
      Way::SpaceDel(\$_);
      if($file =~ /\.$_$/) { $ck = 0; last; }
      else { $ck = 1; }
    }
  }
if($ck) { push(@FileListTmp, $file); }
}
@FileList = @FileListTmp; undef @FileListTmp;
}

sub FileSelectAct {
  my $dir = shift;
  my (@dirs, @files, $filename, $newdir);
  opendir(dir, $dir);
    @dirs = grep  {!(/^\./) && -d "$dir/$_" } readdir(dir);
    rewinddir(dir);
    @files = grep  {!(/^\./) && -T "$dir/$_" } readdir(dir);
  closedir(dir);
  foreach (@dirs) {
    $newdir = $dir . "/" . $_;
     my $ck =1;
     foreach (split(/\,+/, $Lc{ExceptDir})) { 
       Way::SpaceDel(\$_); 
       if($_ eq $newdir) { $ck = 0; last; } }
     if($ck) { FileSelectAct($newdir); }
  }
  foreach (@files) {
    $filename = $dir . "/" . $_; push(@FileList, $filename); }
return 1;
}

sub Search {
my ($Range, $FileList) = @_;
local *FILE;
if($Dc{Word} eq '') { return; }
my ($file, $content, $title, $key, $name);
foreach $file (@$FileList) {
  open(FILE, "$file") or next;
    $content = ''; while (<FILE>) { chomp $_; $content .= $_; }
  close(FILE);
  ($title) = $content =~ /<TITLE> *([^<]+) *<\/TITLE>/i;
  ($description) =
  $content =~ /<META *NAME *= *"?description"? *content *= *"?([^"^>]*)"?>/i;
  ($keywords) =
  $content =~ /<META *NAME *= *"?keywords"? *content *= *"?([^"^>]*)"?>/i;
  $antitag = $content;
  $antitag =~ s/<[^>]*(>|$)//ig;
  # $antitag =~ s/^[^>]*>//i;
  ($filename) = $file =~ m{([^\\^/]+)$};
  foreach $Range (@$Range) {
    if($Range =~ /^Title$/i) { SearchAct($title, $file, $title, 1); }
    if($Range =~ /^Key$/i)   { SearchAct($keywords, $file, $title, 2); }
    if($Range =~ /^Text$/i)  { SearchAct($antitag, $file, $title, 3); }
    if($Range =~ /^File$/i)  { SearchAct($filename, $file, $title, 4); }
  }
}
return @Find;
}

sub SearchAct {
my ($data, $filename, $title, $Range) = @_;
my $cnt;
if($Dc{Meth} eq "phrase") {
  if($cnt = ($data =~ s/$Dc{Word}/$Dc{Word}/ig)) {
    my $findinfo = "$filename \0 $title \0 $Range \0 $cnt";
    push(@Find, $findinfo); }
}
else {
  my $sum;
  foreach $word (split(/ +/, $Dc{Word})) {
    if($cnt = ($data =~ s/$word/$word/ig)) { $sum += $cnt; }
    elsif($Dc{Meth} eq "and") { $sum = 0; last; }
  }
  if($sum) {
    my $findinfo = "$filename \0 $title \0 $Range \0 $sum";
    push(@Find, $findinfo); }
}
}

sub Result {
my ($Range, $Find) = @_;
foreach (@$Find) {
  my ($filename, $title, $Range, $cnt) = split(/ \0 /, $_);
  if($Result{$filename}->{name}) {
     if($Result{$filename}->{range} > $Range) {
       $Result{$filename}->{range}  = $Range;
       $Result{$filename}->{cnt}    = $cnt; }
  }
  else {
    $Result{$filename}->{name}  = $filename;
    $Result{$filename}->{title} = $title;
    $Result{$filename}->{range} = $Range;
    $Result{$filename}->{cnt}   = $cnt;
  }
    $Result{$filename}->{sum}  += $cnt;
}
foreach (keys %Result) {
  my @tmp = ($Result{$_}->{name}, $Result{$_}->{title}, $Result{$_}->{range},
             $Result{$_}->{cnt}, $Result{$_}->{sum});
  push(@Result, \@tmp)
}
@Result = sort { 
my ($a1, $a2, $a3, $a4, $a5) = @$a;
my ($b1, $b2, $b3, $b4, $b5) = @$b;
$a3 <=> $b3 || $b4 <=> $a4 || $b5 <=> $a5 || $a2 cmp $b2
} @Result;
my $Count = $#Result+1;

my ($PageCount, $PageS, $PageE);
if($Dc{Count} =~ /^All$/i) {
  $PageCount = 1;
  $Dc{Page} = 1;
  $PageS = 0;
  $PageE = $#Result;
  }
else {
$PageCount = $Count / $Dc{Count};
$PageCount =~ s/\..*$//g;
if($Count % $Dc{Count}) { $PageCount ++; }
$Dc{Page} || ($Dc{Page} = 1);
$Dc{Page} = ($Dc{Page} > $PageCount ? $PageCount : $Dc{Page});
$PageS = $Dc{Count} * ($Dc{Page} - 1);
$PageE = $Dc{Count} * $Dc{Page} - 1;
$PageE = ($#Result < $PageE ? $#Result : $PageE);
}
@Result = @Result[$PageS..$PageE];
my ($PgN, $PgP);
if($Dc{Page} < $PageCount) { $PgN = $Dc{Page} + 1; }
if($Dc{Page} > 1) { $PgP = $Dc{Page} - 1; }
my $no = $PageS;

local (*MAIN, *HEAD, *BODY, *TAIL);
open(MAIN, "./form/main.html");
  while(<MAIN>) { $main .= $_; }
close(MAIN);
open(HEAD, "./form/head.html");
  while(<HEAD>) { $head .= $_; }
close(HEAD);
open(BODY, "./form/body.html");
  while(<BODY>) { $body .= $_; }
close(BODY);
open(TAIL, "./form/tail.html");
  while(<TAIL>) { $tail .= $_; }
close(TAIL);

foreach (@$Range) { $range_dsp{$_} = "CHECKED"; }
$meth_dsp{$Dc{Meth}} = "CHECKED";
$count_dsp{$Dc{Count}} = "SELECTED";

my $pages = $PageS + 1;
my $pagee = $PageE + 1;

$word_dsp = $Dc{Word};
$word_dsp =~ s/\"/&quot;/g;

$input_box = <<"__END__";

<FORM METHOD=GET ACTION="$ENV{SCRIPT_NAME}">

<INPUT TYPE=HIDDEN NAME=LocalConfig VALUE=$Dc{LocalConfig}>

<TABLE BORDER=0>
<TR>
<TD>$Mc{NameWord}</TD>
<TD>
<INPUT TYPE=TEXT NAME="Word" SIZE=30 VALUE="$word_dsp">
&nbsp;&nbsp;<INPUT TYPE=SUBMIT VALUE="Search!">
</TD>
</TR>
<TR>
<TD>$Mc{NameMeth}</TD>
<TD>
<INPUT TYPE=RADIO NAME=Meth VALUE="or" $meth_dsp{or}>$Mc{NameOr} &nbsp;
<INPUT TYPE=RADIO NAME=Meth VALUE="and" $meth_dsp{and}>$Mc{NameAnd} &nbsp;
<INPUT TYPE=RADIO NAME=Meth VALUE="phrase" $meth_dsp{phrase}>$Mc{NamePhrase}
&nbsp; &nbsp;
$Mc{NameCount} &nbsp; <SELECT NAME="Count">
    <OPTION $count_dsp{'10'}>10
    <OPTION $count_dsp{'15'}>15
    <OPTION $count_dsp{'20'}>20
    <OPTION $count_dsp{'25'}>25
    <OPTION $count_dsp{'30'}>30
    <OPTION $count_dsp{'All'}>All
</SELECT>
</TD>
</TR>
<TR>
<TD>$Mc{NameRange}</TD>
<TD>
<INPUT TYPE=CHECKBOX NAME="Title" $range_dsp{Title}>$Mc{NameTitle}
&nbsp;
<INPUT TYPE=CHECKBOX NAME="Key" $range_dsp{Key}>$Mc{NameKey}
&nbsp;
<INPUT TYPE=CHECKBOX NAME="Text" $range_dsp{Text}>$Mc{NameText}
&nbsp;
<INPUT TYPE=CHECKBOX NAME="File" $range_dsp{File}>$Mc{NameFileName}
</TD>
</TR>
</FORM>
</TABLE>

__END__

if($Dc{Word} eq '') { $result_msg = $Mc{RequiredKeyword}; }
elsif (!$Count) { $result_msg = $Mc{DocNotFound}; }
else {
       $pg_range = "($pages-$pagee/$Count)";
       $result_msg = $Mc{DocFound};
       $result_msg =~ s/\%1/$Count/g;
       $result_msg =~ s/\%2/$pg_range/g; }

$head =~ s/::INPUT-BOX::/$input_box/g;
$head =~ s/::RESULT-MSG::/$result_msg/g;

if($PgP) {
  $PgP = "<A HREF=\"$ENV{SCRIPT_NAME}?$Query&Page=$PgP\">$Mc{NamePrev}</A>"; }
else { $PgP = "$Mc{NamePrev}"; }
if($PgN) {
  $PgN = "<A HREF=\"$ENV{SCRIPT_NAME}?$Query&Page=$PgN\">$Mc{NameNext}</A>"; }
else { $PgN = "$Mc{NameNext}"; }
my $link = "[
<A HREF=\"$Lc{HomeUrl}\" TARGET=\"$Lc{HomeTarget}\">$Mc{NameHome}</A> -
$PgP - $PgN ]";
my ($page, @p);
$page = "[ ";
if (!$PageCount) {
  $page .= "1"; }
else {
  foreach (1..$PageCount) {
    if($_ eq $Dc{Page}) { push(@p, "$_"); }
    else { push(@p, "<A HREF=\"$ENV{SCRIPT_NAME}?$Query&Page=$_\">$_</A>"); }
  }
}
$page .= join(" - ", @p);
$page .= " ]";
$tail =~ s/::LINK::/$link/g;
$tail =~ s/::PAGE::/$page/g;

foreach (@Result) {
if(!@$Find) { last; }
  $no ++;
  my ($name, $title, $range, $cnt, $sum) = @$_;
  my $size = -s "$name";
  my $time = (stat "$name")[9];
  $time = Way::GetDate($Lc{DateType}, $time, $Gc{TimeAdjust});
  if($title eq '') { $title = $Mc{NonTitle}; }
  if($range eq 1) { $range = $Mc{NameTitle}; }
  if($range eq 2) { $range = $Mc{NameKey}; }
  if($range eq 3) { $range = $Mc{NameText}; }
  if($range eq 4) { $range = $Mc{NameFimeName}; }
  Way::Comma(\$size);
  my $tmp;
  foreach $tmp (split(/\,+/, $Lc{SearchDir})) {
    my ($dir, $url) = $tmp =~ /^([^\[]*)\[?([^\]]*)\]?$/;
    chop $dir if $dir =~ /\/$/;
    Way::SpaceDel(\$dir, \$url);
    $name =~ s/^$dir\//$url/;
  }
  $Body = $body;
  $Body =~ s/::NO::/$no/g;
  $Body =~ s/::URL::/$name/g;
  $Body =~ s/::TARGET::/$Lc{Target}/g;
  $Body =~ s/::TITLE::/$title/g;
  $Body =~ s/::RANGE::/$range/g;
  $Body =~ s/::TIME::/$time/g;
  $Body =~ s/::BYTE::/$size/g;
  $BODY .= $Body;
}
$main =~ s/::TABLE-HEAD::/$head/g;
$main =~ s/::TABLE-BODY::/$BODY/g;
$main =~ s/::TABLE-TAIL::/$tail/g;
Way::HtmlHeader();
print $main;
exit;
}

