################################
# Way-LIB
################################

package Way;

###########################################################################
# Config
###########################################################################

sub GetConf {
# USAGE : ,  ϸ
# GetConf(*Cf, "FileName");
# foreach (sort keys %Cf) {
#   foreach $tmp (sort keys %{$Cf{$_}}) {
#      print "$_ -> $tmp : $Cf{$_}{$tmp}\n"; } }
local *conf = shift;
my $file = shift;
local *CONF;
my $tmp;
open(CONF, "$file") or return 0;
  while(<CONF>) {
    if(m,^\[\s*(.*)\s*\]$,i) { if($1 ne $tmp) { $tmp = $1; next; } }
    chomp $_;
    next if $_ =~ /^\ *#/;
    my ($key, $val) = $_ =~ /^\s*(\w+)\s+(.*)/;
    $key =~ s/^[ \t]+|[ \t]+$|\r$//g;
    $val =~ s/^[ \t]+|[ \t]+$|\r$|\cM//g;
    my $section = $tmp;
    ($section =~ s/^\s*LOCAL\s*(.*)$/$1/i) || ($section = "_Global");
    $conf{$section}->{$key} = $val if $key ne '';
  }
close(CONF);
return 1;
}

###########################################################################
# Form
###########################################################################

sub DataConv {
# USAGE : (Hash), (Key Array)
#   DataConv(*Dc);
#   foreach (keys %Dc) { print "$_ : ^$Dc{$_}^\n"; }
#   Ͼε
#   ENCTYPE="multipart/form-data"
#   $Dc{file}->{data}, {name}, {size}, {type} - ?
local *Input = shift;
local *List = shift;
my $form;
if($ENV{'REQUEST_METHOD'} eq "GET") {
  $form = $ENV{'QUERY_STRING'}; }
if($ENV{'REQUEST_METHOD'} eq "POST") {
  binmode STDIN;
  read(STDIN, $form, $ENV{'CONTENT_LENGTH'}); }
if($form !~ /\n/) {
foreach (split(/&/, $form)) {
  my ($key, $value) = split(/=/, $_);
  $key   =~ tr/+/ /; 
  $value =~ tr/+/ /;
  $key   =~ s/%(..)/pack("C", hex($1))/ge;
  $value =~ s/%(..)/pack("C", hex($1))/ge;
  $Input{$key} = (defined $Input{$key}?"$Input{$key}\0$value":"$value"); 
  push(@List, $key); }
}
else {
  my ($key, $value);
  my ($border) = ($form =~ /^(.+?)\r?\n/);
  $form =~ s/${border}--\r?\n?$//;
  my $badchar = '`~!@#%^&*()|,<>?;:\'"[]{}';
  foreach (split /$border/, $form) {
    next if $_ eq ''; s/^\r?\n//;
    if(/^.+?name="([^\"]*)"; filename="(.+?)"/i) {
      next if $2 eq ''; $key = $1;
      my ($FILE_NAME) = $2 =~ m,([^/\\]+)$,;
      $FILE_NAME =~ s/[$badchar]//g; $FILE_NAME =~ s/ /_/g;
      $Input{$key}->{name} = $FILE_NAME;
      s/^.+?\r?\n\r?\n//s; s/\r?\n$//s;
      if($_ eq '') { $Input{$key}->{name} = ''; next; }
      $Input{$key}->{data} = $_;
      $Input{$key}->{size} = length($Input{$key}->{data});
      push(@List, $key) }
    else { s/^.+?name="([^\"]*)"\r?\n\r?\n(.+?)\r?\n$//s;
      ($key = $1) =~ tr/\r//d;
      ($value = $2) =~ tr/\r//d;
      if($key ne '') {
        $Input{$key} = (defined $Input{$key}?"$Input{$key}\0$value":"$value");
        push(@List, $key); }
    }
  }
}
}

###########################################################################
# Filesystem
###########################################################################

sub BaseName {
# ־  ο ϸ 
# USAGE : ϸ, ⳻( : 0,  : 1)
#   print BaseName("/usr/bin/perl", 1), "\n";
my $filename = shift;
my $type = shift;
my $file = $path = $filename;
$file =~ s,.*[/\\],,;
$path =~ s,$file$,,;
if (!$type)       { return $file; }
if ($type eq "1") { return $path; }
}

###########################################################################
# Sort
###########################################################################

sub SortHash {
# ؽ   Ͽ Ű迭 ϴ Լ
# DATE : 19991007
# USAGE : (, ), Ĺ(, ), ؽ
#   @result = &SortHash(1, 1, %data);
#   foreach (@result) { print "$_ : $data{$_}\n"; }

my ($divi, $rev, %hash) = @_;
my @keys;
if($divi) { @keys = sort { $hash{$a} <=> $hash{$b} } keys %hash; }
  else { @keys = sort { $hash{$a} cmp $hash{$b} } keys %hash; }
if(!$rev) { @keys = reverse @keys; }
return @keys;
}

###########################################################################
# Header
###########################################################################

sub DownLoad {
my ($sysname, $downname) = @_;
local *DOWN;
defined $downname || (($downname) = $sysname =~ m,([^/\\]+)$,);
open(DOWN, "$sysname") or return 0;
print "Content-type: application/octet-stream\n";
print "Content-disposition: attachment; filename=$downname\n\n";
binmode(DOWN); binmode(STDOUT); print <DOWN>;
close(DOWN);
return 1;
}

sub HtmlHeader {
print "Content-type: text/html\n\n";
}

sub LocationHeader {
my $url = shift;
print "Location: $url\n\n";
}

sub CookieSet {
my $name  = shift;
my $value = shift;
my $exp   = shift;
=head
From: CGI.pm(expire)
$time = time;
my(@MON)=qw/Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec/;
my(@WDAY) = qw/Sun Mon Tue Wed Thu Fri Sat/;
my($sec,$min,$hour,$mday,$mon,$year,$wday) = gmtime($time);
$year += 1900;
$result = sprintf("%s, %02d$sc%s$sc%04d %02d:%02d:%02d GMT",
#$result = sprintf("%s, %02d-$sc%s-$sc%04d %02d:%02d:%02d GMT",
                   $WDAY[$wday],$mday,$MON[$mon],$year,$hour,$min,$sec);
print $result, "\n";
=cut
if($exp) { $exp = "expires=" . scalar localtime(time+(24*60*60)*$exp) . ";"; }
   else { $exp = ""; }
 print "Content-type: text/html\n";
 print "Set-Cookie: $name=;\n";
 print "Set-Cookie: $name=$value;$exp\n";
}

sub CookieRead {
# USAGE : 
#   CookieRead(*COOKIE);
#   foreach (keys %COOKIE) { print "$_ : ^$COOKIE{$_}^\n"; }
local *cookie = shift;
my ($name, $value);
foreach (split(/; /,$ENV{'HTTP_COOKIE'})) {
 my ($name, $value) = split(/=/, $_);
 $value =~ tr/+/ /;
 $value =~ s/%(..)/pack("C", hex($1))/ge;
 $cookie{$name} = $value; }
}

###########################################################################
# Check
###########################################################################

sub CheckMail {
my ($data, $nodata) = @_;
($data eq "" && $nodata) && return 1;
if ($data =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)/ ||
    $data !~ /^.+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,3}|[0-9]{1,3})(\]?)$/)
   { return 0; } else { return 1; }
}
sub CheckLen {
my ($data, $min, $max, $nodata) = @_;
($data eq "" && $nodata) && return 1;
if( (length($data) <= $max) &&
    (length($data) >= $min) ) { return 1; } else { return 0; }
}
sub CheckRegNo {
my ($data, $nodata) = @_;
($data eq "" && $nodata) && return 1;
if(length($data) eq 13) { $data =~ s/^(.{6})(.{7})$/$1-$2/g; }
if(length($data) eq 10) { $data =~ s/^(.{3})(.{2})(.{5})$/$1-$2-$3/g; }
my @etno = split(//, $data);
if(length($data) eq 14) {
  if($etno[6] ne "-") { return 0; }
  if($etno[7] > 0) { 
  if(abs((11-($etno[0]*2+$etno[1]*3+$etno[2]*4+$etno[3]*5+$etno[4]*6+
              $etno[5]*7+$etno[7]*8+$etno[8]*9+$etno[9]*2+$etno[10]*3+
              $etno[11]*4+$etno[12]*5)%11)%10) eq $etno[13])
              { return 1; } else { return 0; } }
  elsif($etno[7] eq 0) { 
  if(abs((10-($etno[0]*1+$etno[1]*2+$etno[2]*1+$etno[3]*2+$etno[4]*1+
              $etno[5]*2+$etno[7]*1+$etno[8]*2+$etno[9]*1+$etno[10]*2+
              $etno[11]*1+$etno[12]*2)%10)%10) eq $etno[13])
              { return 1; } else { return 0; } }
  else { return 0; } 
}
if(length($data) eq 12) { 
  if($etno[3] ne "-" || $etno[6] ne "-") { return 0; }
  my $sum = $etno[0]*1+$etno[1]*3+$etno[2]*7+$etno[4]*1+$etno[5]*3+
            $etno[7]*7+$etno[8]*1+$etno[9]*3;
  my $tmp = $etno[10]*5;
  $tmp = ($tmp < 10 ? "0$tmp" : $tmp);
  my ($tmp1, $tmp2) = $tmp =~ /(.)(.)/;
  $sum += $tmp1 + $tmp2; $sum = chop $sum; 
  $sum = abs(10-$sum); $sum = chop $sum;
  if($sum eq $etno[11]) { return 1; } else { return 0; }
}
}
sub CheckNum {
my ($data, $mark, $nodata) = @_;
my $mark2;
($data eq "" && $nodata) && return 1;
foreach (split(//, $mark)) { $mark2 .= "\\$_"; }
if($data =~ /^[0-9$mark2]+$/) { return 1; } else { return 0; }
}
sub CheckEng {
my ($data, $mark, $nodata) = @_;
my $mark2;
($data eq "" && $nodata) && return 1;
foreach (split(//, $mark)) { $mark2 .= "\\$_"; }
if($data =~ /^[a-zA-Z$mark2]+$/) { return 1; } else { return 0; }
}
sub CheckEngNum {
my ($data, $mark, $nodata) = @_;
my $mark2;
($data eq "" && $nodata) && return 1;
foreach (split(//, $mark)) { $mark2 .= "\\$_"; }
if($data =~ /^[a-zA-Z0-9$mark2]+$/) { return 1; } else { return 0; }
}
sub CheckHangul {
my ($data, $nodata) = @_;
($data eq "" && $nodata) && return 1;
my $data_tmp;
my $mark = chr(30);
($data_tmp = $data) =~ s/([\xB0-\xC8\xA1-\xFE])/$mark$1/;
unless($data_tmp =~ /$mark[\xB0-\xC8\xA1-\xFE]/) { return 0; }
return 1;
}

###########################################################################
# Display
###########################################################################

sub GoBackMsg {
my ($msg, $msg2, $page) = @_;
defined $page || ($page = 1);
$msg =~ s/\\/\\\\/g; $msg2 =~ s/\\/\\\\/g;
$msg =~ s/\n/\\n/g;  $msg2 =~ s/\n/\\n/g;
$msg =~ s/\"/\\\"/g; $msg2 =~ s/\"/\\\"/g;
$msg && ($msg .= "\\n\\n");
HtmlHeader();
print <<"__END__";
<HTML>
<HEAD>
<TITLE></TITLE>
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="0">
</HEAD>
<BODY>
<SCRIPT LANGUAGE="JavaScript">
<!--
  alert("$msg$msg2");
  history.go(-$page);
//-->
</SCRIPT>
</BODY>
</HTML>
__END__
}

sub GoBack {
my $page = shift;
defined $page || ($page = 1);
HtmlHeader();
print <<"__END__";
<HTML>
<HEAD>
<TITLE></TITLE>
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="0">
</HEAD>
<BODY>
<SCRIPT LANGUAGE="JavaScript">
<!--
  history.go(-$page);
//-->
</SCRIPT>
</BODY>
</HTML>
__END__
}

###########################################################################
# String
###########################################################################

sub Comma {
# Ҽ Ե  ĸ ִ Լ
# DATE : 19991007
# USAGE : ڷ
#   Comma(\$a, \$b, \$c, \$d, \$e);
my @data = @_;
foreach (@data) {
my ($cf) = ($$_ =~ /^([^\.]*)/);
my ($cb) = ($$_ =~ /\.(.*)$/);
$cf =~ s/\D//g; $cf += 0; $cb =~ s/\D|0+$//g; $cb && ($cb = ".$cb");
1 while $cf =~ s/(\d+)(\d{3})/$1,$2/;
$$_ = "$cf$cb"; }
}

sub SpaceDel {
# ڷ հ ڿִ  ϴ Լ
# Ѿ    ״ 迭 ѱ
# USAGE
#   SpaceDel(\$a, \$b, \$c, \$d, \$e);
my @data = @_;
foreach (@data) { $$_ =~ s/^ +| +$//g; }
}

sub EnterConv {
# Ѿ   Ǵ Mac Ҽ ๮ 
# USAGE
#   EnterConv(\$a, \$b, \$c, \$d, \$e);
my @data = @_;
foreach (@data) {
$$_ =~ s/\cM//g;
$$_ =~ s/\r\n/\n/g;
$$_ =~ s/\r/\n/g; }
}

sub HtmlLink {
my $data = shift;
$data =~ s/([^(\"|')]|^)((http|https|ftp|telnet|news):\/\/[A-Za-z0-9:&#=_\?\/~\.\+-]+)/$1<A HREF=\"$2\">$2<\/A>/g;
$data =~ s/([A-Za-z0-9]+@[A-Za-z0-9-]+\.[A-Za-z0-9-\.]+)/<A HREF=\"mailto:$1\">$1<\/A>/g;
return $data;
}

sub QuoteConv { foreach (@_) { $$_ =~ s/\\/\\\\/g; $$_ =~ s/\'/\\'/g; } }
sub QuoteDeConv { foreach (@_) { $$_ =~ s/\\\\/\\/g; $$_ =~ s/\\'/\'/g; } }

sub WidthConv {
my ($data, $len, $mark, $pos) = @_;
my $tmp  = "$mark" x ($len-length($data));
my $tmp2 = "$mark" x (($len-length($data))/2);
my $tmp3 = "$mark" x (($len-length($data))-length($tmp2));
if($pos eq "L") { $width = $data . $tmp; }
elsif($pos eq "R") { $width = $tmp . $data; }
elsif($pos eq "C") { $width = $tmp2 . $data . $tmp3; }
return $width;
}

sub InsertTab {
# 
# USAGE : print "$data", InsertTab(length($data), 5, 1), "\n";
#
my $pre  = shift; # պκ ¹ڿ (byte)
my $col  = shift; # ڰ ġ TAB ÷(byte/8)
my $over = shift; # պκ ڿ TAB ÷ Ѿ ź 
my $tab;
$len = $pre/8;
$len -- if $len =~ /\./;
$tab = $col-$len;
$tab = 1 if $over and $tab < 1;
return "\t" x $tab;
}

###########################################################################
# Mail
###########################################################################

sub SendMail {
my ($SendType, $MailProg, $Server, $Admin,
    $From, $FromName, $To, $Cc, $Bcc, $Subject, $Message,
    $MailType,
    $AttachList, $Attach,
    $CharSet, $TextEncode) = @_;
local *MAIL;
my $r;
my $Boundary = "___==" . "MultiPart_" . time()*2 . "_" . $$ . "==___";
if($#$AttachList >= 0) {
 foreach (@$AttachList) { Base64E(\$$Attach{$_}->{data}); } }
my (@ToArr, @CcArr, @BccArr);
if(ref($To) eq "ARRAY") { @ToArr = @$To; }
  else { $To && (@ToArr = ($To)); }
if(ref($Cc) eq "ARRAY") { @CcArr = @$Cc; }
  else { $Cc && (@CcArr = ($Cc)); }
if(ref($Bcc) eq "ARRAY") { @BccArr = @$Bcc; }
  else { $Bcc && (@BccArr = ($Bcc)); }
if(!$SendType) { $SendType = (-x $MailProg ? 1 : 2); }
if($SendType eq 1) {
 open(MAIL, "|$MailProg -t -f $Admin") or return 0; }
else {
use Socket;
$r = "\r";
$Server || ($Server = "127.0.0.1");
my $proto = (getprotobyname('tcp'))[2];
my $port  = (getservbyname('smtp', 'tcp'))[2];
my $smtp  = ($server =~ /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/)
               ? pack ('C4',$1,$2,$3,$4) : (gethostbyname $server)[4];
socket(MAIL, AF_INET, SOCK_STREAM, $proto) || return 0;
connect(MAIL, pack('Sna4x8', AF_INET, $port, $smtp)) || return 0;
my ($old) = select(MAIL); $|=1; select($old);
my $sock = <MAIL>;
  if($sock =~ /^[45]/) { close MAIL; return 0; }
print MAIL "HELO $Server\r\n";
$sock = <MAIL>;
  if($sock =~ /^[45]/) { close MAIL; return 0; }
print MAIL "MAIL FROM: $Admin\r\n";
$sock = <MAIL>;
  if($sock =~ /^[45]/) { close MAIL; return 0; }
foreach (@ToArr, @CcArr, @BccArr) {
  print MAIL "RCPT TO: $_\r\n";
  $sock = <MAIL>;
  if($sock =~ /^[45]/) { close MAIL; return 0; }
 }
print MAIL "DATA\r\n";
$sock = <MAIL>;
  if($sock =~ /^[45]/) { close MAIL; return 0; }
}
   print MAIL "From: $From ($FromName)$r\n";
foreach (@ToArr) { print MAIL "To: $_$r\n"; }
foreach (@CcArr) { print MAIL "Cc: $_$r\n"; }
foreach (@BccArr) { print MAIL "Bcc: $_$r\n"; }
if($#$AttachList >= 0) {
   print MAIL "Mime-Version: 1.0$r\n";
   print MAIL "Content-type: MULTIPART/MIXED; BOUNDARY=\"$Boundary\"$r\n"; }
elsif($MailType) {
   print MAIL "Mime-Version: 1.0$r\n";
   print MAIL "Content-Type: text/html; charset=$CharSet$r\n"; }
   print MAIL "Subject: $Subject$r\n";
   print MAIL "X-Mailer: Way-SERIES Mailer 1.0 Perl - http://way.co.kr$r\n$r\n";
if($#$AttachList < 0) {
   print MAIL "$Message$r\n"; }
else {
   print MAIL "This is a multi-part message in MIME format.$r\n";
   print MAIL "$r\n";
   print MAIL "--$Boundary$r\n";
   if($MailType) {
   print MAIL "Content-Type: text/html; charset=$CharSet$r\n";
   print MAIL "Content-Transfer-Encoding: $TextEncode$r\n$r\n"; }
   else {
   print MAIL "Content-Type: text/plain; charset=$CharSet$r\n";
   print MAIL "Content-Transfer-Encoding: $TextEncode$r\n$r\n"; }
   print MAIL "$Message$r\n";
   foreach (@$AttachList) {
   print MAIL "--$Boundary$r\n";
   print MAIL "Content-Type: application/octet-stream;";
   print MAIL " name=\"$$Attach{$_}->{name}\"$r\n";
   print MAIL "Content-Transfer-Encoding: base64$r\n";
   print MAIL "Content-Disposition: attachment;";
   print MAIL " filename=\"$$Attach{$_}->{name}\"$r\n";
   print MAIL "$r\n";
   print MAIL $$Attach{$_}->{data}, "\n"; }
   print MAIL "--$Boundary--$r\n"; }
if($SendType eq 1) { close(MAIL); }
else {
print MAIL "\r\n.\r\n";
$sock = <MAIL>;
  if($sock =~ /^[45]/) { close MAIL; return 0; }
print MAIL "QUIT\r\n";
close(MAIL);
}
return 1;
}

sub Base64E {
my $res;
my $data = shift;
while($$data =~ /(.{1,45})/gs) {
  chop (my $t = substr(pack('u', $1), 1));
  $t =~ tr|` -_|AA-Za-z0-9+/|; $res .= $t; }
my $padding = (3 - length($data) % 3) % 3;
$res =~ s/.{$padding}$/'=' x $padding/e if $padding;
$res =~ s/(.{1,76})/$1\r\n/g;
$$data = $res;
}

###########################################################################
# Time
###########################################################################

sub GetDate {
=head
 ǥĿ ° ϴ Լ
ð   ð ν
DATE : 20000107
USAGE : ǥ, ð, 
  print GetDate("W1 M4 D2 H1:I1:S1 KST Y1", undef, 12*60*60), "\n";
===================================#
 ǥ
===================================#
         Y1 = 0000-9999
             Y2 = 00-99
           M1 = 01-12
             M2 = 1-12
             M3 = January-December
             M4 = Jan-Dec
           D1 = 01-31
             D2 = 1-31
         W1 = Sun-Sat
             W2 = Sunday-Saturday
             W3 = -
             W4 = -
           H1 = 00-23
             H2 = 0-23
             H3 = 01-12
             H4 = 1-12
  /  A1 = AM-PM
             A2 = am-pm
             A3 = -
           I1 = 00-59
             I2 = 0-59
           S1 = 00-59
             S2 = 0-59
===================================#
=cut

my ($type, $time, $adjust) = @_;
defined $type || ($type = "Y1-M1-D1 H1:I1:S1");
defined $time || ($time = time());
$time += $adjust;
my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst)
      = (defined $adjust ? gmtime($time) : localtime($time));
$year += 1900 if length $year < 4;
$year += 100 if $year < 1970;
$mon ++;
my $hour12 = ($hour > 12 ? $hour - 12 : $hour);
$hour12 == 0 && ($hour12 = 12);
my @wd1 = qw(Sun Mon Tue Wed Thu Fri Sat);
my @wd2 = qw(Sunday Monday Tuesday Wednesday Thursday Friday Saturday);
my @wd3 = qw(  ȭ    );
my @wd4 = qw(      );
my @m1  = qw(January February March April May June July August September
             October November December);
my @m2  = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
my %dt;
$dt{Y1} = $year;
$dt{Y2} = substr($year,2,2);
$dt{M1} = ($mon < 10 ? "0$mon" : $mon);
$dt{M2} = $mon;
$dt{M3} = $m1[$mon-1];
$dt{M4} = $m2[$mon-1];
$dt{D1} = ($mday < 10 ? "0$mday" : $mday);
$dt{D2} = $mday;
$dt{W1} = $wd1[$wday];
$dt{W2} = $wd2[$wday];
$dt{W3} = $wd3[$wday];
$dt{W4} = $wd4[$wday];
$dt{H1} = ($hour < 10 ? "0$hour" : $hour);
$dt{H2} = $hour;
$dt{H3} = ($hour12 < 10 ? "0$hour12" : $hour12);
$dt{H4} = $hour12;
$dt{A1} = ($hour < 12 ? "AM" : "PM");
$dt{A2} = ($hour < 12 ? "am" : "pm");
$dt{A3} = ($hour < 12 ? "" : "");
$dt{I1} = ($min < 10 ? "0$min" : $min);
$dt{I2} = $min;
$dt{S1} = ($sec < 10 ? "0$sec" : $sec);
$dt{S2} = $sec;
foreach (keys %dt) { $type =~ s/$_/$dt{$_}/; }
return $type;
}

sub GetTimeValue {
#  ̿ؼ 1970/01/01 sec++  ȯ
my ($year, $month, $date, $hour, $minute, $second, $adjust) = @_;
my ($re_time, $tmp);
$month += 0;
defined $adjust || ($adjust = LocalTimeGap());
my @month_arr = (31, 0, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
if($year < 1970 || $year > 2070) { return 0; }
if($month > 3) {
   foreach (1..$month-1) {
   if($_ eq 2) { $re_time += (GetTimeValue'February($year)*86400); }
   else { $re_time += ($month_arr[$_-1]*86400); } } }
else { if($month eq 3) { $re_time += ((GetTimeValue'February($year)*86400)
                         + (31*86400)); }
       if($month eq 2) { $re_time += (31*86400); } }
$re_time += GetTimeValue'YearToTime($year) + ($date-1)*86400 + $hour*3600;
$re_time += $minute*60 + $second;
$re_time -= $adjust;
return $re_time;
}
sub GetTimeValue'February {
my $year = shift; (($year-1972)%4) && return 28; return 29; }
sub GetTimeValue'YearToTime { my $year = shift; my $sum;
if($year > 1970) { foreach (1970..$year-1) {
  $sum += 86400 * (337+GetTimeValue'February($_)); } }
return $sum;
} 

sub LocalTimeGap {
# 2000/07/01   gmt local о鿩
# , ð, , ʸ   .
my $time = shift;
$time = ($time ? 962409600 : $time);
my @lt = localtime($time);
my @gt =    gmtime($time);
$gap = ($lt[0]+$lt[1]*60+$lt[2]*3600+$lt[7]*86400) -
       ($gt[0]+$gt[1]*60+$gt[2]*3600+$gt[7]*86400);
return $gap;
}

###########################################################################
return 1;
