#!/usr/bin/perl

######################################################################
# CGI Information
#---------------------------------------------------------------------
$Global{DevelName}     = 'Ӵȣ';                  #  
$Global{DevelMail}     = 'lawwal@way.co.kr';        #  E-mail
$Global{DevelHome}     = 'http://way.co.kr';        # Ȩ
$Global{CgiName}       = 'Way-FORM';                # CGI Ī
$Global{CgiVersion}    = '1.5';                     # CGI 
$Global{LastModified}  = '2000-06-12';              #  
######################################################################
# History
#---------------------------------------------------------------------
# 1998-08-08          by lawwal Ver 1.0
# 1999-02-26          by lawwal Ver 1.2
# 1999-04-27          by lawwal Ver 1.3 (Plus WinNT/98/95)
# 1999-11-04 ~ 11-06  by lawwal Ver 1.5 beta
# 2000-06-11 ~ 06-12  by lawwal Ver 1.5
######################################################################
# General Library
#---------------------------------------------------------------------
require "../lib/Way-LIB.cgi";
######################################################################
# CGI Main
#---------------------------------------------------------------------
main();
sub main {
Way::DataConv(*Dc, *Ds);
ReadConf();
LimitAccess();
@ToMailArr = DataUsing();
CheckData();
FileUpload();
@Data = DataSet();
FileSave(@Data);
MailSend(@Data);
Result();
}
######################################################################
# Using Variable
#---------------------------------------------------------------------
#  $Dc{LocalConfig};
######################################################################
# Read Configure
#---------------------------------------------------------------------
sub ReadConf { 
Way::GetConf(*Gc, "../conf/general.cgi");
  %Gc = %{$Gc{_Global}};                           # ⺻
  undef $Gc{TimeAdjust} if $Gc{TimeAdjust} eq '';  # ð
Way::GetConf(*Mc, "../conf/message.cgi");
  %Mc = %{$Mc{_Global}};                           # ޼ 
Way::GetConf(*Lcfg, "../conf/form.cgi");
  %LGlobal = %{$Lcfg{_Global}};                    # Way-FORM ⺻ 
$Dc{LocalConfig} || ($Dc{LocalConfig} = "Default");
  %Lc = %{$Lcfg{$Dc{LocalConfig}}};                # Way-FORM  
# Way-FORM ⺻ Ǿ  ° ⺻ 
foreach (keys %LGlobal) {
  if(defined $LGlobal{$_} && !defined $Lc{$_}) {
     $Lc{$_}  = $LGlobal{$_}; } }
undef %Lcfg; undef %LGlobal;
}
######################################################################

sub LimitAccess {
foreach (split(/,\s?/, $Lc{ExecAllowURL})) {
  if ($ENV{"HTTP_REFERER"} =~ /^$_/i) { $tmp = 1; }
}
if (!$tmp) { Way::GoBackMsg("", $Mc{NotPermUrl}, 1); exit; }
}

sub DataUsing {
$Lc{AdminMail} || ($Lc{AdminMail} = $Gc{AdminMail});
if($Lc{AdminMail} eq "admin\@sample.way.co.kr") {
   Way::GoBackMsg("", $Mc{AdminMailErr}, 1); exit; }
$Lc{ToMail} = ($Lc{ToMail} ? $Lc{ToMail} : $Lc{AdminMail});
$Lc{MaxFileSize} =~ s/\D//g;
$Lc{MaxFileCount} += 0;
#  ּ 迭ȭ
# , ; SPACE Enter
$Lc{ToMail} =~ s/\,+|\;+|\s+|\n+/\|/g;
return split(/\|+/, $Lc{ToMail});
}

sub CheckData {
my @Err;
# Է´׸ 
foreach (split(/\,+/, $Lc{C_Required})) {
  Way::SpaceDel(\$_);
  if($Dc{$_} eq '') {
    my $tmp = $Mc{Required};
    $tmp =~ s/\%1/$_/g; push(@Err, $tmp); }
}
# Էڷ  
foreach (split(/\,+/, $Lc{C_Length})) {
  Way::SpaceDel(\$_);
  my ($data, $range) = $_ =~ /^([^\[]*)\[?([^\]]*)\]?$/;
  my ($min, $max) = split(/\:/, $range);
  Way::SpaceDel(\$data, \$min, \$max);
  if(!Way::CheckLen($Dc{$data}, $min, $max, 1)) {
    my $tmp = $Mc{Length};
    $tmp =~ s/\%1/$data/g;
    if($min eq $max) { $tmp =~ s/\%2/$min/g; }
    else { $tmp =~ s/\%2/$min-$max/g; }
    push(@Err, $tmp); }
}
# ϱĢ 
foreach (split(/\,+/, $Lc{C_Mail})) {
  Way::SpaceDel(\$_);
  if(!Way::CheckMail($Dc{$_}, 1)) {
    my $tmp = $Mc{Mail};
    $tmp =~ s/\%1/$_/g; push(@Err, $tmp); }
}
# Ϲȣ Ģ 
foreach (split(/\,+/, $Lc{C_RegNo})) {
  Way::SpaceDel(\$_);
  if(!Way::CheckRegNo($Dc{$_}, 1)) {
    my $tmp = $Mc{RegNo};
    $tmp =~ s/\%1/$_/g; push(@Err, $tmp); }
}
# ġ ׸ 
foreach (split(/\,+/, $Lc{C_Same})) {
  Way::SpaceDel(\$_);
  my ($data, $data2) = $_ =~ /^([^\[]*)\[?([^\]]*)\]?$/;
  Way::SpaceDel(\$data, \$data2);
  if($Dc{$data} ne $Dc{$data2}) { 
    my $tmp = $Mc{Same};
    $tmp =~ s/\%1/$data, $data2/g; push(@Err, $tmp); }
}
# , ,  
my $char;
foreach $char ("Eng", "Num", "EngNum") {
  foreach (split(/\,+/, $Lc{"C_$char"})) {
    Way::SpaceDel(\$_);
    my ($data, $mark) = $_ =~ /^([^\[]*)\[?([^\]]*)\]?$/;
    Way::SpaceDel(\$data);
    my $charfunc = "Way::Check$char";
    if(!&$charfunc($Dc{$data}, $mark, 1)) {
      my $tmp = $Mc{$char};
      my $tmp2 = $Mc{Mark};
      if($mark) {
       $mark = join(",", split(//, $mark));
       $mark =~ s/ /$Mc{Space}/g;
       $tmp2 =~ s/\%1/$mark/g; }
      else { $tmp2 = ""; }
      $tmp =~ s/\%1/$data/g;
      $tmp =~ s/\%2/$tmp2/g;
      push(@Err, $tmp); }
  }
}
# ÷ ũ üũ
foreach (1..$Lc{MaxFileCount}) {
  my $tmp = $Mc{MaxFileSizeOver};
  if($Dc{"File$_"}->{size} > $Lc{MaxFileSize}) {
    $tmp =~ s/\%1/$Dc{"File$_"}->{name}/g; push(@Err, $tmp); }
}
if(@Err) { ErrorPrint(@Err); }
}

sub ErrorPrint {
my @Err = @_;
my $ErrStr;
foreach (sort @Err) { $ErrStr .= " - $_ \n"; }
Way::GoBackMsg($Mc{Error}, $ErrStr, 1); exit;
}

sub FileUpload {
if($Lc{UpLoadDir} eq '') { return 0; }
if(!-d $Lc{UpLoadDir}) {
## ERR
  Way::GoBackMsg("Config or System Error!",
  " - Directory not exist : $Lc{UpLoadDir}", 1); exit; }
my $tmp;
foreach $tmp (1..$Lc{MaxFileCount}) {
  if($Dc{File.$tmp}->{name} eq '') { next; }
  my ($tmpfile, $tmpext) = $Dc{File.$tmp}->{name} =~ /^([^\.]*)\.?(.*)$/;
  my $cnt = '';
  while(-e "$Lc{UpLoadDir}/$tmpfile$cnt.$tmpext") { $cnt ++; }
  $Dc{File.$tmp}->{name} = "$tmpfile$cnt.$tmpext";
  local *FILE;
## ERR
  open(FILE, ">$Lc{UpLoadDir}/$Dc{File.$tmp}->{name}") or return 0;
    binmode(FILE);
    print FILE $Dc{File.$tmp}->{data};
  close(FILE);
}
}

sub DataSet {
$Subject  = ($Lc{Subject} ne '' ? $Lc{Subject} : "Non Title");
$FromName = ($Dc{$Lc{FromName}} ne '' ? $Dc{$Lc{FromName}} : "");
$FromMail = ($Dc{$Lc{FromMail}} ne '' ? $Dc{$Lc{FromMail}} : "");
my $data = '';
$data  = "=" x 75 . "\n";
$data .= "$Lc{L_Subject} : $Lc{Subject}\n";
my $tmp;
if($FromMail ne '') { $tmp = " ($FromMail)"; }
$data .= "$Lc{L_FromName} : " . $FromName . "$tmp\n" if $FromName;
$data .= "$Lc{L_Date} : " .
         Way::GetDate($Lc{DateType}, time(), $Gc{TimeAdjust}) . "\n";
$data .= "-" x 75 . "\n";
foreach (grep(!/^LocalConfig$|^File\d+$/, @Ds)) {
  if($Dc{$_} !~ /\n/) { $data .= " $_ : $Dc{$_}\n"; }
  else { $data .= " $_ :\n$Dc{$_}\n"; }
 }
foreach (1..$Lc{MaxFileCount}) {
  if($Dc{File.$_}->{name} eq '') { next; }
  $data .=  " File$_ : $Lc{UpLoadDir}/$Dc{File.$_}->{name}";
  Way::Comma(\$Dc{File.$_}->{size});
  $data .= " ($Dc{File.$_}->{size} byte)\n";
}
if($Lc{UserEnv} eq "Y") {
$data .= "-" x 75 . "\n";
$data .= " REMOTE_ADDR : $ENV{REMOTE_ADDR}\n";
$data .= " HTTP_USER_AGENT : $ENV{HTTP_USER_AGENT}\n";
}
$data .= "=" x 75 . "\n";
return ($data, $Subject, $FromName, $FromMail);
}

sub FileSave {
my ($Data, $Subject, $FromName, $FromMail) = @_;
if($Lc{Receptionist} !~ /File/i) { return 0; }
if($Lc{SaveDir} eq '') { return 0; }
if(!-d $Lc{SaveDir}) {
## ERR
  Way::GoBackMsg("Config or System Error!",
  "- Directory not exist : $Lc{SaveDir}", 1); exit; }
my $Fileinfo;
if($Lc{FileNameRule} eq 1) { $Fileinfo = ''; }
elsif($Lc{FileNameRule} eq 2) {
  $Fileinfo = Way::GetDate("Y1M1", time(), $Gc{TimeAdjust}); }
elsif($Lc{FileNameRule} eq 3) {
  $Fileinfo = Way::GetDate("Y1M1D1", time(), $Gc{TimeAdjust}); }
elsif($Lc{FileNameRule} eq 4) {
  $Fileinfo = Way::GetDate("Y1M1D1H1I1S1", time(), $Gc{TimeAdjust}) . $$; }
local *FILE;
## ERR
open(FILE, ">>$Lc{SaveDir}/$Lc{FileName}$Fileinfo.$Lc{FileExt}")  or return 0;
  print FILE $Data;
close(FILE);
}

sub MailSend {
my ($Data, $Subject, $FromName, $FromMail) = @_;
if($Lc{Receptionist} !~ /Mail/i) { return 0; }
if(!@ToMailArr) { return 0; }

$FromName = ($FromName ? $FromName : "Nobody");
$FromMail = ($FromMail ? $FromMail : "Nobody");
my $Message = $Data;
my $MailType = 0;
$Message .= " = Powered by Way-SERIES  ......  http://way.co.kr =\n";

my @AttachList;
if($Lc{UpLoadFileAttach} eq "Y") {
  foreach (1..$Lc{MaxFileCount}) {
    if($Dc{"File$_"}->{name} ne '') { push(@AttachList, "File$_"); }
  }
}
$rs = Way::SendMail(0, $Gc{SendmailPath}, $Gc{SMTPServer}, $Lc{AdminMail},
$FromMail, $FromName, \@ToMailArr, \@Cc, \@Bcc, $Subject, $Message,
$MailType,
\@AttachList, \%Dc,
$Gc{CharSet}, $Gc{MailTextEncode});
if(!$rs) { Way::GoBackMsg("", $Mc{MailSend}, 1); exit; }
}

sub Result {
if($Lc{ResultURL}) { Way::LocationHeader($Lc{ResultURL}); exit; }
else { Way::GoBackMsg("", $Mc{ReceiveResult}, 2); exit; }
}

